/** 
 *   Juego: Clase "de apoyo" casi vaca que lanza la presentacin
 *  
 *   @see Hardware
 *   @author 1-DAI IES San Vicente 2009/10
 */

/* --------------------------------------------------         
   Parte de Death Pit - Remake
   Versiones hasta la fecha:
   
   Num.   Fecha       Por / Cambios
   ---------------------------------------------------
   0.15  28-Ene-2010  Estibaliz Garcia y Nacho Cabanes
                      Aparece una pantalla de creditos
   0.23  25-May-2010  Gemma Vicedo, Jose Carlos Rabasco
                      Se puede volver haciendo clic con el ratn
 ---------------------------------------------------- */
public class Creditos
{
    // Atributos
    private Fuente fuenteSans18;
    protected short coordenadax, coordenaday;
    protected string[] lineas =
    {
      "PROGRAMA REALIZADO POR:", 
      " ",
      "  Helios Pastor Aracil",    
      "  Jos Manuel Rizo Alonso",
      "  Jos Javier Perez Perez",
      "  Alejandro Ferrandiz Lillo",
      "  Joaqun Montoya Ruiz", 
      "  Gemma Vicedo Jover",
      "  Estibaliz Garca Diego",
      "  Sacha Van de Sijpe Bueno",
      "  Mario Matas Ad",
      "  Juan Antonio Domenech Rubio",  
      "  Jose Carlos Rabasco", 
      "  Fran Asensi",
      "  Diego Ibaez Ortuo",
      "  Ignacio Botte Garca",
      "  Miguel Rosario Salinas",
      "  Nacho Cabanes"
    };
    
    private ElemGrafico personaje, enemigo;
    private short xPersonaje, yPersonaje, xEnemigo, yEnemigo;

    public Creditos()  // Constructor
    {
        fuenteSans18 = new Fuente("FreeSansBold.ttf", 18);
        coordenadax = 200;
        coordenaday = 50;
        
        personaje = new ElemGrafico("imagenes/personajei1.png" );
        xPersonaje = 800; yPersonaje = 450;
        enemigo = new ElemGrafico("imagenes/aranya1.png");
        xEnemigo = 880; yEnemigo = 450;
    }
    
    /// Lanza la pantalla de creditos
    public  void Ejecutar()
    {
      //que borrar la pantalla, escribir los nombres de los autores 
      /*y mostrar hasta que se pulse una tecla una animacin, 
       * en la que el escorpin perseguir al personaje de derecha a 
       * izquierda de la pantalla, desapareciendo por el extremo izquierdo
       *  y volviendo a aparecer por el extremo derecho.*/
       
    bool salir = false;

    // Muestra los nombres y la animacion hasta que se pulse una tecla de ESC
    while (! salir )
    {
      Hardware.BorrarPantallaOculta(0,0,0); // Borro en negro
      
      Hardware.EscribirTextoOculta(
          "Pulsa ESC para volver...",
          100,550,0xAA, 0xAA, 0xAA, fuenteSans18);

      // Son varias lneas
      for(int i = 0; i < lineas.Length; i++)
      {
        Hardware.EscribirTextoOculta(
            lineas[i], coordenadax, (short) (coordenaday + i*20),
            (byte) (200 - i*8), (byte) (200 - i*8), (byte) (200 - i*8),
            fuenteSans18);
      }
      
      //Dibuja al personaje y el enemigo siguiendole
      personaje.DibujarOculta(xPersonaje, yPersonaje);
      enemigo.DibujarOculta(xEnemigo, yEnemigo);
      
      xPersonaje -= 5;
      if (xPersonaje < -50) xPersonaje = 800;
      
      xEnemigo -= 5;
      if (xEnemigo < -50) xEnemigo = 800;
      
      Hardware.VisualizarOculta();
      Hardware.Pausa(40);

      // Se puede salir pulsando ESC
      salir = Hardware.TeclaPulsada (Hardware.TECLA_ESC);

      // O bien haciendo clic con el ratn
      int posXRaton, posYRaton;
      if (Hardware.RatonPulsado(out posXRaton, out posYRaton))
      {
          salir = true;
      }


    }
  }

    
} /* fin de la clase Creditos */
