﻿/** 
 *   Juego: Clase "de apoyo" casi vacía que lanza la presentación
 *  
 *   @see Hardware
 *   @author 1-DAI IES San Vicente 2009/10
 */
 
 
/* --------------------------------------------------         
   Parte de Death Pit - Remake
   Versiones hasta la fecha:
   
   Num.   Fecha       Por / Cambios
   ---------------------------------------------------
   0.01  08-Sep-2009  Nacho Cabanes
                      Version inicial: muestra una imagen
   0.02  07-Oct-2009  Nacho Cabanes
                      Mueve el personaje hacia la derecha
                        hasta llegar al margen
   0.03  13-Oct-2009  Nacho Cabanes
                      El personaje se mueve con flechas
                      Un primer enemigo que se mueve a la vez
   0.04  16-Oct-2009  Nacho Cabanes
                      Primera pantalla de presentacion
                      El primer enemigo rebota en los lados
                      Un segundo enemigo nos persigue
   0.05  20-Oct-2009  Nacho Cabanes
                      Array de enemigos (murcielagos)
                       que rebotan en los lados
   0.06  28-Oct-2009  Nacho Cabanes
                      Array bidimensional para imagen de fondo
   0.07  04-Nov-2009  Nacho Cabanes
                      El personaje se mueve solo por los "huecos"
                      Eliminados los enemigos (por ahora)
                      Renombradas variables i,j a fila,colum
   0.08  10-Nov-2009  Nacho Cabanes
                      Varias funciones para que el fuente sea mas modular
   0.09  16-Nov-2009  Nacho Cabanes
                      Varias pantallas conectadas
   0.10  24-Nov-2009  Nacho Cabanes
                      Un enemigo que se mueve "por los huecos"
   0.11  02-Dic-2009  Nacho Cabanes
                      Si chocamos con enemigo perdemos una vida
   0.12  04-Dic-2009  Nacho Cabanes
                      El personaje cambia de imagen según la dirección
                      Si choco con un enemigo de lado, muere él y me da puntos  
   0.13  11-Dic-2009  Joaquín, Alejandro, Miguel; retoques por Nacho
                      Cuando acaban las vidas o se pulsa ESC, acaba la partida,
                      se vuelve a la presentación y se puede volver a empezar
   0.14  23-Dic-2009  Nacho Cabanes
                      Primera versión desglosada en clases. Casi todo el 
                      contenido de "Juego" pasa a "Partida".
   0.15  28-Ene-2010  Helios Pastor
                      Se puede entrar a la pantalla de Creditos, si se
                      escoge esa opcion en la Presentacion.
 ---------------------------------------------------- */


public class Juego
{
    private Presentacion presentacion;
    private Partida partida;
    private Creditos creditos;

    
    // Inicialización al comenzar la sesión de juego
    public Juego()
    {
        // Inicializo modo grafico 800x600 puntos, 24 bits de color
        Hardware.Inicializar(800, 600, 24, true);
        
        // Inicializo componentes del juego
        presentacion = new Presentacion();
        partida = new Partida();
        creditos = new Creditos();
    }
    
    
    
    // --- Comienzo de un nueva partida: reiniciar variables ---
    public void Ejecutar()
    {    
        do
        {
            presentacion.Ejecutar();
            switch( presentacion.GetOpcionEscogida() )
            {
                    case Presentacion.OPC_PARTIDA: 
                        partida.BuclePrincipal();
                        break;
                    
                    case Presentacion.OPC_CREDITOS:
                        creditos.Ejecutar();
                        break;
                   
            }
        }
        while (presentacion.GetOpcionEscogida() != Presentacion.OPC_SALIR );
    }
    
    
    
    // --- Cuerpo del programa -----
    public static void Main() 
    {
        Juego juego = new Juego();
        juego.Ejecutar();
    }
    

    
} /* fin de la clase Juego */

