﻿/** 
 *   Presentacion: pantalla de presentacion
 *  
 *   @see Hardware ElemGrafico Juego
 *   @author 1-DAI IES San Vicente 2009/10
 */

/* --------------------------------------------------         
   Parte de Death Pit - Remake
   Versiones hasta la fecha:
   
   Num.   Fecha       Por / Cambios
   ---------------------------------------------------
   0.14  23-Dic-2009  Nacho Cabanes
                      Primera versión de Presentacion, desglosado de "Juego.cs"
                      No añade posibilidades nuevas.
   0.15  28-Ene-2010  Alejandro Ferrándiz
                      Avisa de que se puede pulsar C para ver los creditos
                      y controla esa opción
   0.23  25-May-2010  Gemma Vicedo, Jose Carlos Rabasco
                      La imagen muestra "botones" para el ratón.
                      Al hacer clic en esos botones, se activa cierta opción
                      Añadida una opción de "Instrucciones", todavía no activa
 ---------------------------------------------------- */

public class Presentacion
{
    // Atributos
    private ElemGrafico imagen;
    private Fuente fuenteSans18;
    private int opcionEscogida;
    private int posXRaton, posYRaton;
    private bool finpresentacion;

    // Opciones posibles
    public const byte OPC_PARTIDA = 0;
    public const byte OPC_SALIR = 1;
    public const byte OPC_CREDITOS = 2;
    public const byte OPC_INSTRUCCIONES = 3;

    /// Constructor
    public Presentacion()  // Constructor
    {
        imagen = new ElemGrafico("imagenes/present_raton.png");
        fuenteSans18 = new Fuente("FreeSansBold.ttf", 18);
        finpresentacion = false;
    }

    /// Lanza la presentacion
    public void Ejecutar()
    {
        //Dibujo la imagen de la presentacion
        imagen.DibujarOculta();

        // La muestro en pantalla

        Hardware.VisualizarOculta();
        finpresentacion = false;
        do
        {
            // Compruebo teclas
            if (Hardware.TeclaPulsada(Hardware.TECLA_J))
            {
                finpresentacion = true;
                opcionEscogida = OPC_PARTIDA;
            }
            if (Hardware.TeclaPulsada(Hardware.TECLA_T))
            {
                finpresentacion = true;
                opcionEscogida = OPC_SALIR;
            }
            if (Hardware.TeclaPulsada(Hardware.TECLA_C))
            {
                finpresentacion = true;
                opcionEscogida = OPC_CREDITOS;
            }
            if (Hardware.TeclaPulsada(Hardware.TECLA_I))
            {
                finpresentacion = true;
                opcionEscogida = OPC_INSTRUCCIONES;
            }
            // Compruebo el raton
            if (Hardware.RatonPulsado(out posXRaton, out posYRaton))
            {
                if ((posXRaton >= 110) && (posYRaton >= 550))
                {
                    if ((posXRaton <= 205) && (posYRaton <= 590))
                    {
                        finpresentacion = true;
                        opcionEscogida = OPC_PARTIDA;
                    }
                }

                if ((posXRaton >= 430) && (posYRaton >= 550))
                {
                    if ((posXRaton <= 540) && (posYRaton <= 590))
                    {
                        finpresentacion = true;
                        opcionEscogida = OPC_CREDITOS;
                    }
                }

                if ((posXRaton >= 570) && (posYRaton >= 550))
                {
                    if ((posXRaton <= 690) && (posYRaton <= 590))
                    {
                        finpresentacion = true;
                        opcionEscogida = OPC_SALIR;
                    }
                }
                if ((posXRaton >= 290) && (posYRaton >= 550))
                {
                    if ((posXRaton <= 350) && (posYRaton <= 590))
                    {
                        finpresentacion = true;
                        opcionEscogida = OPC_INSTRUCCIONES;
                    }
                }
            }

        } while (finpresentacion != true);
        //borro la presentacion
        Hardware.BorrarPantallaOculta(0, 0, 0);

    }

    public int GetOpcionEscogida()
    {
        return opcionEscogida;
    }


} /* fin de la clase Presentacion */
